﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;

public partial class _Default : System.Web.UI.Page 
{
protected void Page_Load(object sender, EventArgs e)
{
    if (!IsPostBack)
    {
        int TotalRows = this.BindGrid(1);
        this.FillJumpToList(TotalRows);
    }
}

private int BindGrid(int CurrentPageNo)
{
    int TotalRows = 0;
    DataTable dt = new DataTable();
    String strConnString = System.Configuration.ConfigurationManager
                .ConnectionStrings["conString"].ConnectionString;
    SqlConnection con = new SqlConnection(strConnString);
    SqlDataAdapter sda = new SqlDataAdapter();
    SqlCommand cmd = new SqlCommand("spx_GetCustomers");
    cmd.CommandType = CommandType.StoredProcedure;
    cmd.Parameters.Add("@TotalRows", SqlDbType.Int)
                .Direction = ParameterDirection.Output;
    cmd.Connection = con;
    sda.SelectCommand = cmd;
    sda.Fill(dt);
    TotalRows = (int)cmd.Parameters["@TotalRows"].Value;
    GridView1.PageIndex = CurrentPageNo - 1;
    GridView1.DataSource = dt;
    GridView1.DataBind();
    return TotalRows;
}

private int CalculateTotalPages(int intTotalRows)
{
    int intPageCount = 1;
    double dblPageCount = (double)(Convert.ToDecimal(intTotalRows) 
                            / Convert.ToDecimal(GridView1.PageSize));
    intPageCount = Convert.ToInt32(Math.Ceiling(dblPageCount));
    return intPageCount;
}

private void FillJumpToList(int TotalRows)
{
    int PageCount = this.CalculateTotalPages(TotalRows);
    for (int i = 1; i <= PageCount; i++)
    {
        ddlJumpTo.Items.Add(new ListItem(i.ToString(), i.ToString()));
    }
}

protected void PageNumberChanged(object sender, EventArgs e)
{
    int PageNo = Convert.ToInt32(ddlJumpTo.SelectedItem.Value);
    this.BindGrid(PageNo);
}
}
