﻿Imports System.Data
Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Dim TotalRows As Integer = Me.BindGrid(1)
            Me.FillJumpToList(TotalRows)
        End If
    End Sub

    Private Function BindGrid(ByVal CurrentPageNo As Integer) As Integer
        Dim TotalRows As Integer = 0
        Dim dt As New DataTable()
        Dim strConnString As String = System.Configuration.ConfigurationManager _
                    .ConnectionStrings("conString").ConnectionString
        Dim con As New SqlConnection(strConnString)
        Dim sda As New SqlDataAdapter()
        Dim cmd As New SqlCommand("spx_GetCustomers")
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.Add("@TotalRows", SqlDbType.Int) _
                        .Direction = ParameterDirection.Output
        cmd.Connection = con
        sda.SelectCommand = cmd
        sda.Fill(dt)
        TotalRows = CInt(cmd.Parameters("@TotalRows").Value)
        GridView1.PageIndex = CurrentPageNo - 1
        GridView1.DataSource = dt
        GridView1.DataBind()
        Return TotalRows
    End Function

    Private Function CalculateTotalPages(ByVal intTotalRows As Integer) As Integer
        Dim intPageCount As Integer = 1
        Dim dblPageCount As Double = CDbl((Convert.ToDecimal(intTotalRows) _
                            / Convert.ToDecimal(GridView1.PageSize)))
        intPageCount = Convert.ToInt32(Math.Ceiling(dblPageCount))
        Return intPageCount
    End Function

    Private Sub FillJumpToList(ByVal TotalRows As Integer)
        Dim PageCount As Integer = Me.CalculateTotalPages(TotalRows)
        For i As Integer = 1 To PageCount
            ddlJumpTo.Items.Add(New ListItem(i.ToString(), i.ToString()))
        Next
    End Sub

    Protected Sub PageNumberChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim PageNo As Integer = Convert.ToInt32(ddlJumpTo.SelectedItem.Value)
        Me.BindGrid(PageNo)
    End Sub
End Class
